--https://eu.battle.net/forums/en/wow/topic/17613332580#post-1
local Player_Name = UnitName("player")
local Player_Realm = GetRealmName()
local g,s,p,d=GetAchievementCriteriaInfo,select,print,0 
local Dungeons=0
local WQs=0
local Kills=0
local TrackerCheckButtons = {}
local TrackerFrame = nil
local frame = CreateFrame("Frame", "TrackerFrame", UIParent)
local frameTex = frame:CreateTexture("Interface\DialogFrame\UI-DialogBox-Border")
local TrackerText = frame:CreateFontString("Progress", "OVERLAY", "GameFontWhite")

-- add this to your SavedVariables or as a separate SavedVariable to store its position
Tracker_Settings = {
	MinimapPos = 45; -- default position of the minimap icon in degrees
	CheckedBox = 1; -- default checked box
	ScreenFrame = false; --default setting for on screen frame
}

-- returns the parameters to follow text on a SendChatMessage to use the last used chat method (sticky chat)
-- CREDIT TO GELLO-UNDERHILL
local function StickyParameters()

  local editBox = ChatFrame1EditBox
  local stickyType = editBox:GetAttribute("stickyType")

  if stickyType=="WHISPER" then
    -- for whispers use tellTarget attribute for name
    return "WHISPER",nil,editBox:GetAttribute("tellTarget")
  elseif stickyType=="CHANNEL" then
    -- for channel chats reuse last-used channelTarget
    return "CHANNEL",nil,editBox:GetAttribute("channelTarget")
  elseif not stickyType then
    -- if no chats send yet, use default /say
    return "SAY"
  else
    -- for everything else ("PARTY","GUILD",etc) use the sticky type
    return stickyType
  end
end

--[[StaticPopupDialogs["ArtifactTrackerDialog"] = {
  text = "Do you want to greet the world today?",
  OnAccept = function()
      print("Hello")
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = false,
  preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
  moveable = trueaw
}--]]



-- Call this in a mod's initialization to move the minimap button to its saved position (also used in its movement)
-- ** do not call from the mod's OnLoad, VARIABLES_LOADED or later is fine. **
function Tracker_MinimapButton_Reposition()
	Tracker_MinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-(80*cos(Tracker_Settings.MinimapPos)),(80*sin(Tracker_Settings.MinimapPos))-52)
end

-- Only while the button is dragged this is called every frame
function Tracker_MinimapButton_DraggingFrame_OnUpdate()

	local xpos,ypos = GetCursorPosition()
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()

	xpos = xmin-xpos/UIParent:GetScale()+70 -- get coordinates as differences from the center of the minimap
	ypos = ypos/UIParent:GetScale()-ymin-70

	Tracker_Settings.MinimapPos = math.deg(math.atan2(ypos,xpos)) -- save the degrees we are relative to the minimap center
	Tracker_MinimapButton_Reposition() -- move the button
end

-- Put your code that you want on a minimap button click here.  arg1="LeftButton", "RightButton", etc
function Tracker_MinimapButton_OnLeftClick()
	if Tracker_Settings.CheckedBox == 1 then --Self only
		print(Player_Name.."-" ..Player_Realm .. " Hidden Artifact Weapon Progress:")
		print(WQs)
		print(Kills)
		print(Dungeons)
	elseif Tracker_Settings.CheckedBox == 2 then --Default chat
		local sticky = StickyParameters
		SendChatMessage(Player_Name.."-" ..Player_Realm .. " Hidden Artifact Weapon Progress:", StickyParameters())
		SendChatMessage(WQs, StickyParameters())
		SendChatMessage(Kills, StickyParameters())
		SendChatMessage(Dungeons, StickyParameters())
	elseif Tracker_Settings.CheckedBox == 3 then -- Say Chat
		SendChatMessage(Player_Name.."-" ..Player_Realm .. " Hidden Artifact Weapon Progress:", "SAY")
		SendChatMessage(WQs, "SAY")
		SendChatMessage(Kills, "SAY")
		SendChatMessage(Dungeons, "SAY")
	elseif Tracker_Settings.CheckedBox == 4 then --Party Chat
		SendChatMessage(Player_Name.."-" ..Player_Realm .. " Hidden Artifact Weapon Progress:", "PARTY")
		SendChatMessage(WQs, "PARTY")
		SendChatMessage(Kills, "PARTY")
		SendChatMessage(Dungeons, "PARTY")
	elseif Tracker_Settings.CheckedBox == 5 then --Raid Chat
		SendChatMessage(Player_Name.."-" ..Player_Realm .. " Hidden Artifact Weapon Progress:", "RAID")
		SendChatMessage(WQs, "RAID")
		SendChatMessage(Kills, "RAID")
		SendChatMessage(Dungeons, "RAID")
	elseif Tracker_Settings.CheckedBox == 6 then --guild Chat
		SendChatMessage(Player_Name.."-" ..Player_Realm .. " Hidden Artifact Weapon Progress:", "GUILD")
		SendChatMessage(WQs, "GUILD")
		SendChatMessage(Kills, "GUILD")
		SendChatMessage(Dungeons, "GUILD")
	end
end


function Tracker_DisplayToolTip()
	GameTooltip:SetOwner(Tracker_MinimapButton, "ANCHOR_RIGHT")
	GameTooltip:SetText(Dungeons.."\r".. WQs.."\r".. Kills .. "\r" .. "Right-Click for Options")
	GameTooltip:Show()
end

function Tracker_SetInfo()
	d=0
	for i = 1, GetAchievementNumCriteria(11152)
		do d = d + s(4, g(11152, i))
	end

	if d > 100 then
		d = 100
	end

	Dungeons = "Dungeons:" ..d.."/"..s(5, g(11152, 1))
	WQs = "WQs: "..s(4, g(11153, 1)).."/"..s(5, g(11153, 1))
	Kills = "Kills: "..s(4, g(11154, 1)).."/"..s(5, g(11154, 1))
end


function Tracker_OnLoad(self)
	self:RegisterForDrag("LeftButton");  

	-- Set up the on screen frame
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)

	-- The code below makes the frame visible, and is not necessary to enable dragging.
	frame:SetPoint("CENTER")
	frame:SetSize(96, 64)
	frameTex:SetAllPoints()
	frameTex:SetColorTexture(0.0, 0.0, 0.0, 0.7)
	TrackerText:SetPoint("CENTER")
	--TrackerText:SetText("WQs \r" .. WQs)
	frame:Hide()
end

function Tracker_OnShow()
	local test = Tracker_Settings.CheckedBox
	SetButtons(test);
end


--local checkboxNumber = 1;
function CreateCheckbuttons()  --)

--[[Self Report Only Button]]
TrackerCheckButtons[1] = CreateFrame("CheckButton", "SelfReportButton_GlobalName", Tracker_Frame, "ChatConfigCheckButtonTemplate");
TrackerCheckButtons[1]:SetPoint("TOPLEFT", 15, -65);
SelfReportButton_GlobalNameText:SetText("Self Only");
TrackerCheckButtons[1]:SetScript("OnClick", 
  function()
  	SetButtons(1)
  	Tracker_Settings.CheckedBox = 1

  end
);

--[[Default Chat Report Only Button]]
TrackerCheckButtons[2] = CreateFrame("CheckButton", "DefaultReportButton_GlobalName", Tracker_Frame, "ChatConfigCheckButtonTemplate");
TrackerCheckButtons[2]:SetPoint("TOPLEFT", 15, -85);
DefaultReportButton_GlobalNameText:SetText("Default Chat");
TrackerCheckButtons[2]:SetScript("OnClick", 
  function()
  	SetButtons(2)
  	Tracker_Settings.CheckedBox = 2
  end
);

--[[Say Report Only Button]]
TrackerCheckButtons[3] = CreateFrame("CheckButton", "SayReportButton_GlobalName", Tracker_Frame, "ChatConfigCheckButtonTemplate");
TrackerCheckButtons[3]:SetPoint("TOPLEFT", 15, -105);
SayReportButton_GlobalNameText:SetText("Say");
TrackerCheckButtons[3]:SetScript("OnClick", 
  function()
  	SetButtons(3)
  	Tracker_Settings.CheckedBox = 3
  end
);

--[[Party Report Only Button]]
TrackerCheckButtons[4] = CreateFrame("CheckButton", "PartyReportButton_GlobalName", Tracker_Frame, "ChatConfigCheckButtonTemplate");
TrackerCheckButtons[4]:SetPoint("TOPLEFT", 15, -125);
PartyReportButton_GlobalNameText:SetText("Party");
TrackerCheckButtons[4]:SetScript("OnClick", 
  function()
  	SetButtons(4)
  	Tracker_Settings.CheckedBox = 4
  end
);

--[[Raid Report Only Button]]
TrackerCheckButtons[5] = CreateFrame("CheckButton", "RaidReportButton_GlobalName", Tracker_Frame, "ChatConfigCheckButtonTemplate");
TrackerCheckButtons[5]:SetPoint("TOPLEFT", 15, -145);
RaidReportButton_GlobalNameText:SetText("Raid");
TrackerCheckButtons[5]:SetScript("OnClick", 
  function()
  	SetButtons(5)
  	Tracker_Settings.CheckedBox = 5
  end
);

--[[Guild Report Only Button]]
TrackerCheckButtons[6] = CreateFrame("CheckButton", "GuildReportButton_GlobalName", Tracker_Frame, "ChatConfigCheckButtonTemplate");
TrackerCheckButtons[6]:SetPoint("TOPLEFT", 15, -165);
GuildReportButton_GlobalNameText:SetText("Guild");
TrackerCheckButtons[6]:SetScript("OnClick", 
  function()
  	SetButtons(6)
  	Tracker_Settings.CheckedBox = 6
  end
);

end


function SetButtons(boxNumber)
	for i = 1, table.maxn(TrackerCheckButtons)
		do TrackerCheckButtons[i]:SetChecked(false)
	end
	TrackerCheckButtons[boxNumber]:SetChecked(true)
end


--[[	checkboxNumber = checkboxNumber + 1;
	
	local checkbutton = CreateFrame("CheckButton", "Tracker_Checkbutton_0" .. checkboxNumber, Tracker_Frame, "ChatConfigCheckButtonTemplate");
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc);
	getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);

	return checkbutton;
end

myCheckButton = ArtifactTracker.createCheckbutton(UIParent, 0, -10, "A Checkbox");
myCheckButton.tooltip = "If this is checked, nothing will happen, because this is a demo checkbox.";
myCheckButton:SetScript("OnClick", 
   function()
      -- do stuff
   end-->
);  ]]
